#include <cstdio>
#include <cstring>

const long long mod = 1000000007;

long long gcd(long long a, long long b)
{
	if (b == 0)
		return a;
	return gcd(b, a%b);
}

long long qpow(long long v, long long st)
{
	long long r = 1;
	while (st)
	{
		if (st&1)
		{
			r = r * v;
			if (r >= mod)
				r %= mod;
		}
		
		v = v * v;
		if (v >= mod)
			v %= mod;
		st /= 2;
	}
	return r;
}

long long fac[1<<20];

int k, n = 0, a[1<<17], b[1<<17];
long long all = 0;

long long mem[1<<20];

long long count(int b[])
{
	int sm = 0;
	for (int i = 0; i < k; i++)
		sm += b[i];
	
	long long ans = fac[sm];
	for (int i = 0; i < k; i++)
	{
		// ans /= fac[ b[i] ];
		ans *= qpow(fac[ b[i] ], mod-2);
		if (ans >= mod)
			ans %= mod;
	}
	
	return ans;
}

int main()
{
	fac[0] = 1;
	for (int i = 1; i < (1<<20); i++)
	{
		fac[i] = fac[i-1]*i;
		if (fac[i] >= mod)
			fac[i] %= mod;
	}

	scanf("%d", &k);
	for (int i = 0; i < k; i++)
	{
		scanf("%d", &a[i]);
		n += a[i];
	}

	memset(mem, -1, sizeof(mem));
	all = count(a);
	for (int i = 1; i < n; ++i)
	{
		int d = gcd(i, n);
		int g = n / d;
		if (mem[g] != -1)
		{
			all += mem[g];
		}
		else
		{
			for (int j = 0; j < k; ++j)
			{
				if (a[j] % g != 0)
				{
					mem[g] = 0;
					goto fail;
				}
				b[j] = a[j] / g;
			}
			all += (mem[g]=count(b));
			if (all >= mod)
				all %= mod;
			fail:;
		}
	}
	if (n&1)
	{
		int odd = -1;
		for (int i = 0; i < k; i++)
		{
			if (a[i]&1)
			{
				if (odd != -1)
					goto fail2;
				odd = i;
			}
		}
		if (odd != -1)
		{
			memcpy(b, a, sizeof(a));
			--b[odd];
			for (int i = 0; i < k; i++)
			{
				b[i] /= 2;
			}
			all += count(b) * n;
			if (all >= mod)
				all %= mod;
		}
		fail2:;
	}
	else
	{
		// no odd ;
		for (int i = 0; i < k; ++i)
		{
			if (a[i]&1)
				goto found_odd;
		}
		
		for (int i = 0; i < k; i++)
		{
			b[i] = a[i] / 2;
		}
		all += count(b)*n/2;
		if (all >= mod)
			all %= mod;
		found_odd:;
		
		// at most 0 or 2 odd.
		int codd = 0;
		for (int i = 0; i < k; i++)
		{
			if (a[i]&1)
				++codd;
		}
		if (codd <= 2)
		{
			for (int i = 0; i < k; i++)
			{
				b[i] = a[i] / 2;
			}
			all += count(b)*n/2;
			if (all >= mod)
				all %= mod;
			if (codd == 2)
			{
				all += count(b)*n/2;
				if (all >= mod)
					all %= mod;
			}
		}
	}
	//~ printf("B %lld\n", all);
	long long ans = all * qpow(2LL*n, mod-2);
	printf("%lld\n", ans % mod);
	return 0;
}
