#include <map>
#include <set>
#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;

const int MAXN = 1 << 16;

struct tree {
    vector<int> f;
    int l, r;
};

int n, q;
int a[MAXN];
int b[MAXN];
tree it[MAXN * 2];
map<int, int> mp;
int m;

void read() {
    scanf("%d", &n);
    for (int i = 0; i < n; i++) {
        scanf("%d", &a[i]);
    }
    
    scanf("%d %d", &q, &m);
}

void init(int p, int l, int r) {
    it[p].l = l;
    it[p].r = r;
    
    vector<int> &w = it[p].f;
    
    for (int i = l; i <= r && i < n; i++) {
        w.push_back(b[i]);
    }
    sort(w.begin(), w.end());
    
    if (l != r) {
        int mid = (l + r) / 2;
        init(p * 2, l, mid);
        init(p * 2 + 1, mid + 1, r);
    }
}

int get(vector<int> &f, int x) {
    int l, r, mid;
    
    l = -1;
    r = (int)f.size() - 1;
    while (l < r) {
        mid = l + (r - l + 1) / 2;
        
        if (f[mid] < x) {
            l = mid;
        } else {
            r = mid - 1;
        }
    }
    
    return l + 1;
}

int ask(int p, int l, int r) {
    if (it[p].r < l || it[p].l > r) return 0;
    if (l <= it[p].l && it[p].r <= r) {
        return get(it[p].f, l);
    }
    
    return ask(p * 2, l , r) + ask(p * 2 + 1, l, r);
}

void solve() {
    for (int i = 0; i < n; i++) {
        if (mp.find(a[i]) == mp.end()) {
            b[i] = -1;
        } else {
            b[i] = mp[ a[i] ];
        }
        mp[ a[i] ] = i;
    }
    
    int p = 1;
    while (p < n) p *= 2;
    init(1, 0, p - 1);
	int R = 0;
    
    while (q --) {
        int x, y, z;
        scanf ("%d%d%d", &x, &y, &z);
		if (m) {
			y ^= R;
			z ^= R;
		}
			
        if (x == 0) {
            printf ("%d\n", R = ask(1, y, z));
        }
    }
}

int main() {
    read();
    solve();
    
    return 0;
}